/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.job.services;

import javax.annotation.Resource;

import net.sourceforge.kivu4j.job.domain.JobDto;
import net.sourceforge.kivu4j.job.domain.TriggerDto;
import net.sourceforge.kivu4j.utils.api.ResultFactory;
import net.sourceforge.kivu4j.utils.job.ScheduleManager;
import net.sourceforge.kivu4j.utils.lang.ConvertUtil;

import org.quartz.JobDetail;
import org.quartz.Trigger;
import org.springframework.stereotype.Service;

/**
 * 窗体结果转换
 *
 * @author Lucky Yang
 */
@Service("jobResultFactory")
public class JobResultFactory extends ResultFactory{
	@Resource
	private ScheduleManager scheduleManager;
	
	public ScheduleManager getScheduleManager() {
		return scheduleManager;
	}

	public void setScheduleManager(ScheduleManager scheduleManager) {
		this.scheduleManager = scheduleManager;
	}

	public JobDto make(JobDetail jobDetail) {
		JobDto dto = new JobDto(jobDetail.getName(),
				jobDetail.getGroup(),
				jobDetail.getFullName(),
				jobDetail.getDescription());
		dto.setID(ConvertUtil.convert(jobDetail.getFullName().hashCode(), Long.class));
		return dto;
	}

	public TriggerDto make(Trigger trigger) {
		int state = this.scheduleManager.getTriggerState(trigger.getName(),
				trigger.getGroup());
		TriggerDto dto = new TriggerDto(trigger.getJobName(),
				trigger.getJobGroup(),
				trigger.getName(),
				trigger.getGroup(),
				trigger.getFullName(),
				trigger.getDescription(), 
				ConvertUtil.convert(trigger.getNextFireTime(), String.class),
				state);	
		dto.setID(ConvertUtil.convert(trigger.getFullName().hashCode(), Long.class));
		return dto;
	}
}
