/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.job.services;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import net.sourceforge.kivu4j.job.domain.Timetable;
import net.sourceforge.kivu4j.job.domain.TimetableDto;
import net.sourceforge.kivu4j.utils.api.ResultFactory;

import org.springframework.stereotype.Service;

/**
 * 窗体结果转换
 *
 * @author Lucky Yang
 */
@Service("timetableResultFactory")
public class TimetableResultFactory extends ResultFactory{
	public TimetableDto make(Timetable timetable) {
		return this.map(timetable, TimetableDto.class);
	}

	public Collection<TimetableDto> make(Collection<Timetable> timetables) {
		List<TimetableDto> rslt = new ArrayList<TimetableDto>();
		if (timetables != null){
			for(Timetable timetable : timetables)
				rslt.add(this.make(timetable));
		}
		return rslt;
	}

	public Timetable make(TimetableDto dto) {
		return this.map(dto, Timetable.class);
	}
}
